#!/bin/sh
MRUFrep="/usr/local/share/MRUF";MRUF="MRUF-lst";corps="$MRUFrep/corps"
case "$@" in #### set -xe
	A|a|H|h)TitrE="############## /usr/local/bin/MRUF-lst-0.9.4.1.sh ##############"
	ExecS="bash, aemenu-pango, replaceit, less, urxvt."
	DonneeS=".mtpaint, (.)recently-used.xbel, geany.conf; options :
   # global_history.dat, bookmarks (links2 & MZ), sqlite*."
	BashS=" hic-et-nunc2.sh, CleanMTPaintHistory.sh,
   # mc.sh, gpl3.sh, sqlitemanager.sh, visionner-avec-less4c.sh, etc.;
   # xdg-open (jemimah), defaulthandler (BK).";FiN="### aemenu-pango (vovchik):
   # murga-linux.com/puppy/viewtopic.php?p=914001&search_id=1239982663#914001
   ######################################################################"
	case "${LANG%_*}" in en)echo -e "\n      $TitrE\n   # Displays the Most Recently Used Files and Directories (MRUF|MRUD).
   # Usable within Puppy with most WM's and FM's. # Adapted for aemenu
   ### (c) Christian L'Écuyer, alias « musher0 » (PuppyLinux forum),
   # Gatineau (Qc), Canada, end of Oct.-beg. of Nov. 2012. ## Edits:
   ### Oct. 15, Nov. 16 2013; June 11 2014, March 13 2015 (MRUD-lst.sh,
   ### v. 0.3 to 0.4b); Aug. 31 - Sept. 18 2016, (v. 0.5 to 0.9.4.1).
   ## /usr/share/doc/MRUF-lst/gpl3.sh will display the licence. (GPL3)\n   #
   # Required -- # Exec.: $ExecS\n   # Data: $DonneeS
   # Bash Scripts: $BashS
   ################   References, credits and thanks:   #################
   ### Icon: Puppus Dogfellow. ## Comm.: Mike Walsh, Lazy Puppy. ###
   # Idea: openbox.org/wiki/Openbox:Pipemenus:recentfilesxbel
   # (Thanks to stu91 for the tip.) $FiN\n
                     (Type 'Enter' to close this panel.)" ;;
     fr)echo -e "\n      $TitrE\n   # Affiche les répertoires et fichiers récemment utilisés. S'utilise
   # dans Puppy|Toutou avec la plupart des gest. de fen. et de fich.\n   #
   # Adapté pour aemenu par (c) Christian L'Écuyer, alias « musher0 »
   # (forum PuppyLinux), Gatineau (Qc), Canada, fin oct. - début nov. 2012.
   ### Révisions : 15 oct., 16 nov. 2013; 11 juin 2014, 13 mars 2015
   ### (v. 0.3 à 0.4b); 31 août - 18 sept. 2016 (v. 0.5 à 0.9.4.1).
   ## /usr/share/doc/MRUF-lst/gpl3.sh affichera la license. (GPL3)\n   #
   # Requis -- # Exéc. : $ExecS\n   # Données: $DonneeS
   # Scripts en bash :$BashS
   ################   Réf., crédits et remerciements :   #################
   ### Icône : Puppus Dogfellow. ## Obs. : Mike Walsh, Lazy Puppy.
   # Idée : openbox.org/wiki/Openbox:Pipemenus:recentfilesxbel
   # (Merci à stu91 pour le « tuyau ».) $FiN\n
                    (Taper 'Entrer' pour fermer ce panneau.)" ;;
     esac;read ;; # Description

	*)# LANG=en_US.UTF8 # Uncomment this line to debug|test the script in English.
	cd $MRUFrep # Habillage par défaut & Variables
	[ ! -f Fonte ] && echo "OpenSans-Light" > Fonte;Caract="`head -1 $MRUFrep/Fonte`"
	[ ! -f Size ] && echo 12 > Size;Size="`head -1 $MRUFrep/Size`"
	[ ! -f Color ] && echo -e "bisque\nsnow" > Color
	Color1="`head -1 $MRUFrep/Color`";Color2="`tail -1 $MRUFrep/Color`"
	if [ ! -f SqlitE ];then
		[ -f /usr/local/bin/sqlitemanager.sh ] && echo "/usr/local/bin/sqlitemanager.sh" > SqlitE
	fi;[ -f SqlitE ] && SqlitE="`head -1 $MRUFrep/SqlitE`"
# For file managers # Thanks to Mike Walsh for this suggestion. # Sept. 5 2016
	[ ! -f FileMan ] && echo rox > FileMan;FM="`head -1 $MRUFrep/FileMan`"
	SpaN2="</span></span>"

# Construction du menu # En-tête
	echo -e "-wide config file for aewm clients\n# This is a dynamic file! # Ce fichier change tout le temps !
# Do not edit directly.  # # Ne pas éditer directement.\n# aemenu pour MRUF-lst.* \n" > /tmp/en-tete
if [ "${LANG%_*}" = "fr" ];then
	DOCREC="Documents récents";DaT="`date '+    %a. %d %b., %R'`"
else
	DOCREC="Recent Documents";DaT="`date '+    %a. %b. %d , %R'`"
fi
echo -e "cmd \"  $DaT\" \"/usr/local/bin/hic-et-nunc2.sh;$MRUF\"
cmd \"<span color='DarkSeaGreen2'>━━━━━━━━━━━━━━━━━</span>\" \"$MRUF\"
cmd \"<span rise='9000' font='$Caract bold $Size'><span color='$Color1'><i>   $DOCREC</i>$SpaN2\" \"$MRUF\"\n# ${LANG%_*}" >> /tmp/en-tete

# Construction du menu # Corps # With language detection.
	if [ ! -f $corps -o "`grep -ow ${LANG%_*} /tmp/en-tete`" = "" ];then
		DepuiS="`echo $DaT | awk '{ print $NF }'`"
# Attente
		CoLoR="bd $Color1 -bg black -fg $Color2"
		case "${LANG:0:2}" in fr)TXTMSG3="L'initialisation prend du temps !
 ... Merci de votre patience ..." ;;
			*)TXTMSG3="   Initialization takes time!
... Thanks for your patience ..." ;;
		esac
		yaf-splash -bw 10 -$CoLoR -font $Caract -fontsize $Size -timeout 7 -margin 7 -outline 0 -text "$TXTMSG3" 2>/dev/null &
#
		echo . > $corps
# Variables
		source /usr/local/share/MRUF/vars.GEN

		[ ! -L $XBel ] && ln -s /root/.local/share/recently-used.xbel $XBel

		case "${LANG%_*}" in
			en)source /usr/local/share/MRUF/vars.EN ;;
			fr)source /usr/local/share/MRUF/vars.FR ;;
		esac # See file /usr/share/doc/MRUF-lst/MRUF-langues.txt to implement other languages.
#
		EnD  (){
		echo end >> $corps
} ##
		BacKuP () {
		BkP="";BkP="cp -f --backup ${j} ${j}.bkp"
		echo -e "cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
	cmd \"$DSeaGR<i>⚫ $EFF  </i>$SpaN2\" \"$BkP;rm -f ${j};rm -f $corps;$MRUF\"" >> $corps
		EnD
} ##
		MRUDMenu (){
		echo -e "menu \"$SpanSizE2<i>⚫ M.R.U.D</i>$SpaN2\"\n$LignESpaN" >> $corps
} ##
		MRUD (){
		for i in `cat /tmp/MRUFprog`;do
			[ -f "$i" ] && echo "cmd \"$i\" \"default${j}editor '$i';$MRUF\"" >> $corps
		done
		MRUDMenu;> /tmp/MRUDprog;dir=""
		for dir in `cat /tmp/MRUFprog | grep -v recent_files`;do
			dirname $dir >> /tmp/MRUDprog
		done
		sort -u /tmp/MRUDprog > /tmp/MRUDprog2;dir=""
		for dir in `cat /tmp/MRUDprog2`;do
			[ -d "$dir" ] && echo "cmd \"$dir\" \"$FM $dir\"" >> $corps
		done
		EnD
} ##
		DefEdVieW () {
		echo -e "$LignESpaN\n   cmd \"   default${j}editor\" \"default${j}editor;$MRUF\"
	cmd \"   default${j}viewer\" \"default${j}viewer;$MRUF\"" >> $corps
		EnD
} ##
		FinD () {
		find "$DiR" -maxdepth 7 -mindepth 2 -name "$NamE" -mtime 0 2>/dev/null
} ##
		echo -e "menu \"$SpanSizE2<i>⚫ ' xbel '</i>$SpaN2\"\n$LignESpaN" >> $corps
#
		echo -e "menu \"$SpanSizE2<i>⚫ $FiL</i>$SpaN2\"\n$LignESpaN" >> $corps # Fichiers généraux
		file="";>/tmp/MRUFxbel.lst
		for file in `awk -F"\"" '/href/ && $2 !~ /'${PicS}'/ { print $2 }' $XBel | tail -n 14`;do
			[ -f "${file#*//}" ] && echo "cmd \"${file#*//}\" \"xdg-open '${file#*//}' || defaulthandler '${file#*//}';$MRUF\"" >> $corps
			dirname "${file#*//}" >> /tmp/dir-catalog # Prép. pour M.R.U.D., 2e ci-dessous.
		done;EnD # of Files section
#
		echo -e "menu \"$SpanSizE2<i>⚫ Images</i>$SpaN2\"\n$LignESpaN" >> $corps # Images
		for image in `awk -F"\"" '$2 ~ /'${PicS}'/ { print $2 }' $XBel | tail -n 14`;do
			[ -f "${image#*//}" ] && echo "cmd \"${image#*//}\" \"xdg-open '${image#*//}' || defaulthandler '${image#*//}';$MRUF\"" >> $corps
		done;EnD # of Images section
#
		echo -e "menu \"$SpanSizE2<i>⚫ $APPS</i>$SpaN2\"\n$LignESpaN" >> $corps # Applications
		for app in `awk -F";" '$1 ~ /exec/ { print $2 }' $XBel | awk '{ print $1 }' | sort -u`;do
			echo "cmd $app \"$app;$MRUF\"" >> $corps
		done;EnD # of Apps section
#
		MRUDMenu;sort -u /tmp/dir-catalog > /tmp/dir-catalog.uniq;dir=""
		for dir in `cat /tmp/dir-catalog.uniq`;do
			echo "cmd \"$dir\" \"$FM $dir\"" >> $corps
		done;EnD # of MRUD section
#
		j="";j="$XBelsrc";echo -e "$LignESpaN" >> $corps
		BacKuP # End of general section | Fin de la section générale | xbel
###
		echo -e "menu \"$SpanSizE2<i>⚫ URLs</i>$SpaN2\"\n$LignESpaN" >> $corps # URLs
#
		NamE="global_history.dat";DiR="/root/.opera";OprAHsT="`FinD`"
		[ "$OprAHsT" = "" ] && DiR="/mnt";OprAHsT="`FinD`"
		if [ "$OprAHsT" != "" ];then
			echo -e "menu \"$SpanSizE2<i>⚫ opera-12.x</i>$SpaN2\"\n$LignESpaN" >> $corps
			for http in `awk '/http/ && $1 !~ /true|log|search|bank|banque/' $OprAHsT | head -n 14`
				do echo -e "cmd \"$http\" \"defaultbrowser '$http';$MRUF\"" >> $corps
			done # Vérifier :	echo "cmd \"opera:history\" \"opera opera:history\"" >> $corps
			BkP="cp -f --backup $OprAHsT $OprAHsT.bkp"
			echo -e "cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
			cmd \"$DSeaGR<i>⚫ $EFF  </i>$SpaN2\" \"[ "`ps | awk '$4 ~ /opera/'`" = "" ] && $BkP && rm -f $OprAHsT;rm -f $corps;$MRUF\"
			$LignESpaN" >> $corps # Erasing opera's history works only if opera is not running.
			echo "cmd \"opera\" \"opera;$MRUF\"" >> $corps
		EnD;fi # of opera-12.x section.
#
		rLksBkMks="/root/.links/bookmarks.html";if [ -f $rLksBkMks ];then
			echo -e "menu \"$SpanSizE2<i>⚫ links2</i>$SpaN2\"\n$LignESpaN" >> $corps
			for http in `awk -F"\"" '$2 ~ /http/ && $2 !~ /startpage|google|moz|seamonkey|banque|bank/ { print $2 }' $rLksBkMks | tail -n 14 | sort -u`;do
				echo "cmd \"$http\" \"defaulthtmlviewer $http;$MRUF\"" >> $corps
			done
			echo -e "cmd \"$SpanSizE3<i>⚫ (pseudo-$HistoriQ)</i>$SpaN2\" \"$MRUF\"
$LignESpaN\ncmd \"defaulthtmlviewer\" \"defaulthtmlviewer\"" >> $corps
		EnD;fi # of links2 section. # pseudo-history
#
		NamE="places.sqlite";DiR="/root/.mozilla";PlacE="`FinD`"
		[ "$PlacE" = "" ] && DiR="/mnt";PlacE="`FinD`"
		if [ "$PlacE" != "" ];then
			echo -e "menu \"$SpanSizE2<i>⚫ MZ</i>$SpaN2\"\n$LignESpaN" >> $corps
			MZ="`find / -maxdepth 6 -name bookmarks.html | grep -E -v "sda|links" | tail -n 1`"
# Fallback if we don't have a sql program to process the places.sqlite file.
			if [ "$MZ" != "" ];then # Line below: Unix timestamp for today, less 30 days.
				a="`date +%s`";let b=30*24*60*60;let c=$a-$b
				http="";for http in `awk -F"\"" '$2 ~ /http/ && $2 !~ /startpage|google|moz|seamonkey|banque|bank/ && $6 > '${c}' { print $2 }' $MZ | tail -n 14 | sort -u`;do
				echo "cmd \"$http\" \"defaultbrowser $http;$MRUF\"" >> $corps
				done;echo -e "cmd \"$SpanSizE3<i>⚫ (pseudo-$HistoriQ)</i>$SpaN2\" \"$MRUF\"" >> $corps
			fi # End of MZ bookmarks sub-section.

			if [ -f $MRUFrep/SqlitE ];then # Won't kick in if no sqlite is detected.
				echo -e "$LignESpaN\n   cmd \"places.sqlite\" \"$SqlitE $PlacE;$MRUF\"
			cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $PlacE $PlacE.bkp" >> $corps
			fi # End of places.sqlite sub-section.
			echo -e "$LignESpaN\ncmd \"  $MZbr\" \"seamonkey || firefox || palemoon\"" >> $corps
		EnD;fi # of MZ section.
#
		ViV="`find / -maxdepth 5 -name vivaldi-bin | head -1`";ViV="`dirname $ViV`"
		if [ "$ViV" != "" ];then
			echo -e "menu \"$SpanSizE2<i>⚫ Vivaldi</i>$SpaN2\"\n$LignESpaN
			cmd \"$HistoriQ\" \"cd $ViV;./vivaldi --enable-grouped-history --user-data-dir=profile vivaldi://history;MRUF\"" >> $corps
			pDH="profile/Default/History"
			[ -f $MRUFrep/SqlitE ] && echo "cmd \"$HistoriQ (local)\" \"cd $ViV;$SqlitE $pDH;$MRUF\"
			cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cd $ViV;cp -f --backup $pDH $pDH.bkp\"" >> $corps
		EnD;fi # of Vivaldi section.
#
		if [ "`which chromium`" ];then # Based on peebee's chromium-44 sfs
			echo -e "menu \"$SpanSizE2<i>⚫ Chromium</i>$SpaN2\"\n$LignESpaN
			cmd \"$HistoriQ\" \"chromium chrome://history;$MRUF\"" >> $corps
			cDH="/root/.config/chromium/Default/History"
			[ -f $MRUFrep/SqlitE ] && echo "cmd \"$HistoriQ  (local)\" \"$SqlitE $cDH;$MRUF\"
			cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $cDH $cDH.bkp;$MRUF\"" >> $corps
		End;EnD;fi # Pourquoi 2 fois ? # End of Chromium section.
#
		echo -e "$LignESpaN\ncmd \"defaultbrowser\" \"defaultbrowser;$MRUF\"
		cmd \"defaulthtmlviewer\" \"defaulthtmlviewer;$MRUF\"" >> $corps
		EnD # of URLs section.
###
		GNYconf="/root/.config/geany/geany.conf";if [ -f $GNYconf ];then # Skipped if no Geany.
			echo -e "menu \"$SpanSizE2<i>⚫ Geany</i>$SpaN2\"\n$LignESpaN" >> $corps
			cd /root/.config/geany
			grep t_files= geany.conf | tr ";" "\n" | head -n 14 | sort -u > /tmp/MRUFprog
			j="";j="text";MRUD
			BkP="";BkP="cp -f --backup $GNYconf $GNYconf.bkp"
			echo -e "cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"$BkP;$MRUF\"
			cmd  \"$DSeaGR<i>⚫ $EFF  </i>$SpaN2\" \"$BkP;replaceit --input=$GNYconf --wholeline recent_files= recent_files=;rm -f $corps;$MRUF\"" >> $corps # Erasing works only if Geany is not loaded.
			DefEdVieW
		fi # End of Geany section
###
		rMTPt="/root/.mtpaint";if [ -f $rMTPt ];then # Skipped if no mtpaint.
			echo -e "menu \"$SpanSizE2<i>⚫ Mtpaint</i>$SpaN2\"\n$LignESpaN" >> $corps
			cd /root
			awk '$1 ~ /^file/ && $0 !~ /MRUF/ { print $3 }' $rMTPt | sort -u | head -n 14 > /tmp/MRUFprog
			j="";j="image";MRUD
			echo -e "cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $rMTPt $rMTPt.bkp;$MRUF\"
			cmd  \"$DSeaGR<i>⚫ $EFF  </i>$SpaN2\" \"CleanMTPaintHistory.sh;rm -f $corps;$MRUF\"" >> $corps # Erasing works only if mtpaint is not loaded.
			DefEdVieW
		fi # End of MtPaint section
###
		echo -e "menu \"$SpanSizE2<i>⚫ bash+Syst.</i>$SpaN2\"\n$LignESpaN" >> $corps
#
		j="";j="/root/.bash_history";grep -E -v "exit|run_script" ${j} > /tmp/bashHist
		echo -e "menu \"$SpanSizE2<i>⚫ bash</i>$SpaN2\"\n$LignESpaN
	cmd \"    $HIST\" \"visionner-avec-less4c.sh /tmp/bashHist;$MRUF\"" >> $corps
		BacKuP
#
		echo -e "menu \"$SpanSizE2<i>⚫ less</i>$SpaN2\"\n$LignESpaN" >> $corps
		j="";j="/root/.lesshst"
		echo "cmd \"    ${j#/*/}\" \"visionner-avec-less4c.sh ${j};$MRUF\"" >> $corps
		BacKuP
#
		echo -e "menu \"$SpanSizE2<i>⚫ ' xerrs '</i>$SpaN2\"\n$LignESpaN
	cmd \"    xerrs.log\" \"/usr/local/bin/visionner-xerrs_log-2c.sh;$MRUF\"" >> $corps
		j="";j="/tmp/xerrs.log"
		BacKuP
#
		echo "menu \"$SpanSizE2<i>⚫ ' Xorg.log '</i>$SpaN2\"\n$LignESpaN" >> $corps
		j="";j="/var/log/Xorg.0.log"
		echo -e "cmd \"   Xorg.log\" \"visionner-avec-less4c.sh ${j};$MRUF\"
	cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cp -f --backup ${j} ${j}.bkp;$MRUF\"
end
	$LignESpaN\ncmd \"   console\" \"console-hdr2.sh;$MRUF\"
	cmd \"   less\" \"cd /usr/local/bin;visionner-avec-less4c.sh NQuelTxt;$MRUF\"" >> $corps
		EnD # of Terminal section
###
		echo -e "menu \"$SpanSizE2<i>⚫ GTK+ROX</i>$SpaN2\"\n$LignESpaN" >> $corps
		rGTKBmks="/root/.gtk-bookmarks";if [ -f $rGTKBmks ];then
			echo "menu \"$SpanSizE2<i>⚫ $BmarkS</i>$SpaN2\"\n$LignESpaN" >> $corps
			dir="";for dir in `cat $rGTKBmks`;do
			echo "cmd \"${dir#*//}\" \"$FM ${dir#*//}\"" >> $corps
		done
		echo "cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $rGTKBmks $rGTKBmks.bkp;$MRUF\"" >> $corps
		EnD;fi # of GTK bookmarks
#
		gROUPs="/root/.config/rox.sourceforge.net/ROX-Filer/Groups.xml"
		if [ -f $gROUPs ];then
			echo -e "menu \"$SpanSizE2<i>⚫ Groups</i>$SpaN2\"\n$LignESpaN" >> $corps
			awk -F"<" '$2 ~ /directory/ { print $2 }' $gROUPs | awk -F">" '{ print "cmd "$2" \"rox "$2"\"" }' >> $corps
			echo -e "$LignESpaN
			cmd \"$DSeaGR<i>⚫ $BackuP </i>$SpaN2\" \"cp -f --backup $gROUPs $gROUPs.bkp;$MRUF\"
	cmd \"$DSeaGR<i>⚫ $EdT groups.xml  </i>$SpaN2\" \"defaulttextviewer $gROUPs;$MRUF\"" >> $corps
		EnD;fi # of Groups section
		echo -e "$LignESpaN\ncmd \"   rox\"  \"rox ~\"" >> $corps
		EnD # of GTK & ROX section
###
		echo -e "$SeaGreeN\nmenu \"$SpanColoRbolD<i>         $HlP</i>$SpaN2\"\n$LignESpaN
	cmd \"$SpanSizE2<i>   MRUF-lst-0.9.2.1.sh  (Description)</i>$SpaN2\" \"urxvt -fn xft:Monaco:pixelsize=14:antialias=true:hinting=true -bg linen -fg grey15 -g 80x26 -b 20 -cr orange -bd orange3 +uc -bc +sb -e MRUF-lst h;$MRUF\"\n$LignESpaN" >> $corps
		for ligne in "$LigN1" "$LigN2" "$LigN3";do
			echo "cmd \"$SpanBolD<i>$ligne</i>$SpaN2\" \" \"" >> $corps
		done;echo -e "$LignESpaN\n	cmd \"$SpanBolD<i>$LigN7</i>$SpaN2\" \" \"
	$LignESpaN\n	cmd \"$SpanBolD<i>$LigN6</i>$SpaN2\" \" \"" >> $corps
		[ "`which chromium`" ] && echo -e "$LignESpaN\n	cmd \"$SpanBolD<i>$MayNoTLanD</i>$SpaN2\" \" \"" >> $corps
		echo "   cmd \" \" \" \"" >> $corps
		EnD # of Help section
###
		echo -e "menu \"$SpanColoRbolD<i>         Param.</i>$SpaN2\"\n$LignESpaN
menu \"$SpanColoR1<i>   $HabiT</i>$SpaN2\"\n$LignESpaN
menu \"$SpanColoR1<i>  $ClRs</i>$SpaN2\"\n$LignESpaN" >> $corps
		cd $MRUFrep;for i in `ls -1 ColorS*`;do
			ColorA="`head -1 $i`";ColorB="`tail -1 $i`"
			echo "cmd \"<span fgcolor='$ColorA'><i>  $SchM</i><span fgcolor='$ColorB'><i> $i </i>$SpaN2\" \"cp -f $i Color;rm -f $corps;$MRUF\"" >> $corps
		done
		EnD # Fin du sous-menu des couleurs.
#
		echo -e "menu \"$SpanColoR1<i>  $Taille</i>$SpaN2\"
		cmd \"<span color='$Color2'>━━━━</span>\" \" \"" >> $corps # Sizes
		for i in 8 9 10 11 12 13 14 15 16 17;do
			echo "cmd \"  $i\" \"echo $i > $MRUFrep/Size;rm -f $corps;$MRUF\"" >> $corps
		done
		EnD # Fin du sous-menu des tailles.
#
		[ "${LANG:0:2}" = "fr" ] && FixColors="Test de dépannage contraste" || FixColors="Contrast fix test"
		echo -e "$LignESpaN\n   cmd \"  GTK chtheme\" \"gtk_chtheme_wrapper;$MRUF\"
    cmd \"  $FixColors\" \"/usr/local/bin/Get-Gtk-Theme.sh\"" >> $corps
		EnD # of Dress-up
###
		echo -e "menu \"$SpanColoR1<i>   $FileMan</i>$SpaN2\"\n$LignESpaN" >> $corps
		for flmngr in MidnightCommander_mc.sh PcMan_pcmanfm ROX-Filer_rox Xfe_xfe;do
# You can add any FM you are using in your Puppy by following the above pattern.
			[ "`which ${flmngr#*_}`" ] && echo "cmd \"   ${flmngr%_*}\" \"echo ${flmngr#*_} > $MRUFrep/FileMan;$MRUF\"" >> $corps # < which > to prevent accidents.
		done
		echo "cmd \"$DSeaGR<i> ⚫ $ChoiX  </i>$SpaN2\" \" \"" >> $corps
		EnD # Fin de la section pour le choix du gest. de fichiers.
#
		echo -e "$LignESpaN\n		cmd \"    $mAj $DepuiS \" \" \"
		cmd \"$DSeaGR<i>⚫  $RefresH </i>$SpaN2\" \"rm -f $corps;$MRUF\"" >> $corps
		EnD # of params.
#
		echo -e "cmd \"       <span color='DarkSeaGreen2'>━━━━━━━</span>\" \"$MRUF\"" >> $corps
# Pour déboguer, enlever le "#" ci-dessous. / To debug, remove the "#" below.
		echo "cmd \"<~- $EDT\" \"defaulttextviewer /tmp/recents\"" >> $corps
#
		for i in /tmp/dir-catalog* /tmp/MRUF* /tmp/MRUD*;do rm -f $i 2>/dev/null;done # Nettoyage / Clean-up
		wait ### Fin du / End of / menu
	fi
###
	cat /tmp/en-tete $corps > /tmp/recents # Action
	aemenu-pango -rc /tmp/recents 2>/dev/null ;; # Affichage du menu
esac #### set +xe
